#ifndef _MISC_WORLD_BOUNDS_HPP_
#define _MISC_WORLD_BOUNDS_HPP_

// ------------------------------------------------------------------------------------------------
#include "Common.hpp"
#include "Base/Vector2f.hpp"

// ------------------------------------------------------------------------------------------------
namespace SqMod {

/* ------------------------------------------------------------------------------------------------
 * ...
*/
struct CWorldBounds
{

    /* --------------------------------------------------------------------------------------------
     * ...
    */
    Vector2f min, max;

    /* --------------------------------------------------------------------------------------------
     * ...
    */
    CWorldBounds();

    /* --------------------------------------------------------------------------------------------
     * ...
    */
    CWorldBounds(const Vector2f & vec);

    /* --------------------------------------------------------------------------------------------
     * ...
    */
    CWorldBounds(const Vector2f & min, const Vector2f & max);

    /* --------------------------------------------------------------------------------------------
     * ...
    */
    CWorldBounds(const CWorldBounds & x);

    /* --------------------------------------------------------------------------------------------
     * ...
    */
    CWorldBounds(CWorldBounds && x);

    /* --------------------------------------------------------------------------------------------
     * ...
    */
    ~CWorldBounds();

    /* --------------------------------------------------------------------------------------------
     * ...
    */
    CWorldBounds & operator= (const CWorldBounds & x);

    /* --------------------------------------------------------------------------------------------
     * ...
    */
    CWorldBounds & operator= (CWorldBounds && x);

    /* --------------------------------------------------------------------------------------------
     * ...
    */
    CWorldBounds operator+ (const CWorldBounds & x) const;

    /* --------------------------------------------------------------------------------------------
     * ...
    */
    CWorldBounds operator- (const CWorldBounds & x) const;

    /* --------------------------------------------------------------------------------------------
     * ...
    */
    CWorldBounds operator* (const CWorldBounds & x) const;

    /* --------------------------------------------------------------------------------------------
     * ...
    */
    CWorldBounds operator/ (const CWorldBounds & x) const;

    /* --------------------------------------------------------------------------------------------
     * ...
    */
    bool operator== (const CWorldBounds & x) const;

    /* --------------------------------------------------------------------------------------------
     * ...
    */
    bool operator!= (const CWorldBounds & x) const;

    /* --------------------------------------------------------------------------------------------
     * ...
    */
    SQInteger Cmp(const CWorldBounds & x) const;

    /* --------------------------------------------------------------------------------------------
     * ...
    */
    void Set() const;

    /* --------------------------------------------------------------------------------------------
     * ...
    */
    void Get() const;
};


} // Namespace:: SqMod

#endif // _MISC_WORLD_BOUNDS_HPP_